//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "www,forex-tsd.com"
#property link      "www,forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1  Blue
#property indicator_color2  Red
#property indicator_color3  Blue
#property indicator_color4  Red
#property indicator_color5  Blue
#property indicator_color6  Red
#property indicator_color7  DarkSlateGray
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern int  ChannelPeriod   = 26; 
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsPushNotif = false;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

double Up1[];
double Dn1[];
double mid[];
double mahu[];
double mahd[];
double mahbu[];
double mahbd[];
double trend[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,mahu);  SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,mahd);  SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,mahbu); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,mahbd); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,Up1);
   SetIndexBuffer(5,Dn1);
   SetIndexBuffer(6,mid);
   SetIndexBuffer(7,trend);
return(0);
}

//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
//
//

int deinit() { return(0); }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
//
//

int start()
{
   int limit,i,counted_bars = IndicatorCounted();

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
       limit = MathMin(Bars - counted_bars,Bars-1);     
   
   //
   //
   //
   //
   //
   
   for (i = limit; i >= 0 ; i--)
   {   
      Up1[i] = High[iHighest(NULL,0,MODE_HIGH,ChannelPeriod,i+1)];            
      Dn1[i] =  Low[iLowest(NULL, 0,MODE_LOW, ChannelPeriod,i+1)];
      mid[i] = (Up1[i]+Dn1[i])*0.5;
      trend[i] = trend[i+1];
      mahu[i]  = EMPTY_VALUE;
      mahd[i]  = EMPTY_VALUE;
      mahbu[i] = EMPTY_VALUE;
      mahbd[i] = EMPTY_VALUE;
         if (Close[i]>mid[i]) trend[i] = 1;
         if (Close[i]<mid[i]) trend[i] =-1;
         
         //
         //
         //
         //
         //
         
         if (trend[i]== 1)
         {
            mahu[i]  = High[i]; 
            mahd[i]  = Low[i];
            mahbu[i] = MathMax(Open[i],Close[i]);
            mahbd[i] = MathMin(Open[i],Close[i]);
         }               
         if (trend[i]== -1)
         {
            mahu[i]  = Low[i];
            mahd[i]  = High[i];
            mahbu[i] = MathMin(Open[i],Close[i]);
            mahbd[i] = MathMax(Open[i],Close[i]);
         }               
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Donchian channel signal ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," Donchian channel"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," Donchian channel "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}